library ieee;
use ieee.std_logic_1164.all;

entity conta4 is
  port (rst, clk: in std_logic;
        conto: out std_logic_vector( 0 to 1)
        );
      end conta4;
      
architecture beh of conta4 is
  signal tconto,rconto: std_logic_vector(0 to 1);
  
  begin
    
    conto <=rconto;
    
    --rete combinatoria
    tconto <= "01"   when rconto="00"  else
              "10"   when rconto="01"  else
              "11"   when rconto="10"  else
              "00"   when rconto="11" ;
    --registro          
    rconto <= "00" when rst='1' else
              tconto when clk'event and clk='0';
              
  end beh;
        