library  ieee;
use ieee.std_logic_1164.all;

entity registrog is
   generic ( left : integer range 0 to 127:= 31);
   
   port ( rst,clk: in std_logic;
          din: in std_logic_vector(left downto 0);
          dout: out std_logic_vector(left downto 0)
          );
  end registrog;
  
architecture beh of registrog is
  begin
  
   dout  <= (dout'range => '0') when rst='1' after 1 ns else
             din after 1 ns  when clk'event and clk='0';
end beh;
 
        