library ieee;
use ieee.std_logic_1164.all;

entity tbmcm is
end tbmcm;

architecture tb of tbmcm is
  component mcm is
  port(clk, nw: in std_logic;
       A,B : in integer;
       R: out integer;
       fine: out std_logic);
end component;

signal clk,nw,fine: std_logic;
signal a,b, r: integer;

begin
  dut: mcm port map (clk,nw,a,b,r,fine);
    
  process
    begin
     clk<= '0';
     wait for 5 ns;
     clk <= '1';
     wait for 5 ns;
  end process;
  
  process 
    begin
      nw<='1';
      wait for 11 ns;
      nw <= '0';
      wait until fine= '1';
      wait for 30 ns;
  end process;
  
  process
    begin
      a<= 2;
      b<= 3;
      wait until fine='1';
      wait for 30 ns;
      a<= 4;
      b<= 5;
      wait until fine='1';
      wait for  30 ns;
      a<= 3;
      b<= 7;
      wait until fine='1';
      wait for  30 ns;
      
  end process;
 end  tb;   
