library ieee;
use ieee.std_logic_1164.all;

entity tbmem is
 end  tbmem;
 
 architecture tbm of tbmem is
   
   component memoria is
  port (addr: in integer range 0 to 255;
        cs, rw, oe: in std_logic;
        din: in std_logic_vector(15 downto 0);
        dout: out std_logic_vector(15 downto 0);
        ready: out std_logic);
end component;

signal addr:  integer range 0 to 255;
signal cs, rw, oe, ready:  std_logic;
signal din,dout: std_logic_vector(15 downto 0);

begin
  dut: memoria port map( addr,cs,rw,oe,din,dout,ready);
    
   addr <= 1;
   
   din <= "0000000000001010";
   
   cs <= '1' after 0 ns, '0' after 5 ns, 
         '1' after 15 ns,'0' after 20 ns,
         '1' after 30 ns;
         
   rw <= '0'  after 0 ns, '1' after 15 ns;
   
   oe <= '1' after 0 ns, '0' after 22 ns, '1' after 30 ns;
   
 end tbm;      